Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,39 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    Parameters_test test ("OOO_Engine_Glue");
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,56 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    XML xml ("ooo_engine_glue");
+
+    xml.balise_open("ooo_engine_glue");
+//  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
+    xml.balise_close();
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_ooo_engine::ooo_engine::ooo_engine_glue::Parameters & x)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libReexecute_unit.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/Makefile.deps	(revision 88)
@@ -0,0 +1,45 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Reexecute_unit			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Priority
+include 			$(DIR_MORPHEO)/Behavioural/Generic/Priority/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Reexecute_unit_DIR		=	$(DIR_MORPHEO)/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit
+
+#-----[ Library ]------------------------------------------
+
+Reexecute_unit_LIBRARY		= 	-lReexecute_unit		\
+					$(Priority_LIBRARY)		\
+					$(Behavioural_LIBRARY)	
+
+Reexecute_unit_DIR_LIBRARY	=	-L$(Reexecute_unit_DIR)/lib	\
+					$(Priority_DIR_LIBRARY)		\
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Reexecute_unit_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Priority_library;		\
+				$(MAKE) --directory=$(Reexecute_unit_DIR) --makefile=Makefile;
+
+Reexecute_unit_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) Priority_library_clean;		\
+				$(MAKE) --directory=$(Reexecute_unit_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Reexecute_unit_LIBRARY)
+
+DIR_LIBRARY			= $(Reexecute_unit_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Reexecute_unit_library
+
+library_clean			: Reexecute_unit_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_1.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_1.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_1.cfg	(revision 88)
@@ -0,0 +1,18 @@
+Reexecute_unit
+0	0	+1	# size_context_id         
+0	0	+1	# size_front_end_id       
+6	6	+1	# size_packet_id          
+4	4	+1	# size_queue              
+1	1	+1	# nb_execute_loop         
+4	4	+1	# nb_inst_execute          [0] [nb_execute_loop]
+2	2	+1	# nb_inst_commit          
+2	2	+1	# nb_inst_reexecute       
+1	1	+1	# nb_execute_loop_select  
+0	1	+1	# priority                
+0	1	+1	# load_balancing          
+5	5	+1	# size_general_register_id
+1	1	+1	# size_special_register_id
+32	32	+1	# size_general_data       
+5	5	+1	# size_special_data       
+2	2	+1	# size_store_queue_ptr    
+2	2	+1	# size_load_queue_ptr     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_4.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_4.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-execute_loop_4.cfg	(revision 88)
@@ -0,0 +1,21 @@
+Reexecute_unit
+0	0	+1	# size_context_id         
+0	0	+1	# size_front_end_id       
+6	6	+1	# size_packet_id          
+8	8	+1	# size_queue              
+4	4	+1	# nb_execute_loop         
+4	4	+1	# nb_inst_execute          [0] [nb_execute_loop]
+1	1	+1	# nb_inst_execute          [1] [nb_execute_loop]
+3	3	+1	# nb_inst_execute          [2] [nb_execute_loop]
+8	8	+1	# nb_inst_execute          [3] [nb_execute_loop]
+4	4	+1	# nb_inst_commit          
+3 	3	+1	# nb_inst_reexecute       
+1	4	+1	# nb_execute_loop_select  
+0	1	+1	# priority                
+0	1	+1	# load_balancing          
+5	5	+1	# size_general_register_id
+1	1	+1	# size_special_register_id
+32	32	+1	# size_general_data       
+5	5	+1	# size_special_data       
+2	2	+1	# size_store_queue_ptr    
+2	2	+1	# size_load_queue_ptr     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/config-min.cfg	(revision 88)
@@ -0,0 +1,18 @@
+Reexecute_unit
+0	0	+1	# size_context_id         
+0	0	+1	# size_front_end_id       
+0	0	+1	# size_packet_id          
+1	1	+1	# size_queue              
+1	1	+1	# nb_execute_loop         
+1	1	+1	# nb_inst_execute          [0] [nb_execute_loop]
+1	1	+1	# nb_inst_commit          
+1	1	+1	# nb_inst_reexecute       
+1	1	+1	# nb_execute_loop_select  
+0	1	+1	# priority                
+0	1	+1	# load_balancing          
+5	5	+1	# size_general_register_id
+1	1	+1	# size_special_register_id
+32	32	+1	# size_general_data       
+5	5	+1	# size_special_data       
+1	1	+1	# size_store_queue_ptr    
+0	0	+1	# size_load_queue_ptr     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,30 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  32
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+using namespace morpheo::behavioural::core::multi_ooo_engine;
+using namespace morpheo::behavioural::core::multi_ooo_engine::ooo_engine;
+
+using namespace morpheo::behavioural::core::multi_ooo_engine::ooo_engine::reexecute_unit;
+
+void test    (string name,
+	      morpheo::behavioural::core::multi_ooo_engine::ooo_engine::reexecute_unit::Parameters * param);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,126 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/include/test.h"
+
+#define NB_PARAMS 16
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * size_context_id                            (uint32_t         )\n"));
+  err (_(" * size_front_end_id                          (uint32_t         )\n"));
+  err (_(" * size_packet_id                             (uint32_t         )\n"));
+  err (_(" * size_queue                                 (uint32_t         )\n"));
+  err (_(" * nb_execute_loop                            (uint32_t         )\n"));
+  err (_(" * nb_inst_execute          [nb_execute_loop] (uint32_t         )\n"));
+  err (_(" * nb_inst_commit                             (uint32_t         )\n"));
+  err (_(" * nb_inst_reexecute                          (uint32_t         )\n"));
+  err (_(" * nb_inst_reexecute_commit                   (uint32_t         )\n"));
+  err (_(" * nb_execute_loop_select                     (uint32_t         )\n"));
+  err (_(" * priority                                   (Tpriority_t      )\n"));
+  err (_(" * load_balancing                             (Tload_balancing_t)\n"));
+  err (_(" * size_general_register_id                   (uint32_t         )\n"));
+  err (_(" * size_special_register_id                   (uint32_t         )\n"));
+  err (_(" * size_general_data                          (uint32_t         )\n"));
+  err (_(" * size_special_data                          (uint32_t         )\n"));
+  err (_(" * size_store_queue_ptr                       (uint32_t         )\n"));
+  err (_(" * size_load_queue_ptr                        (uint32_t         )\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc <= static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name = argv[x++];
+  uint32_t            _size_context_id          = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_front_end_id        = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_packet_id           = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_queue               = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _nb_execute_loop          = fromString<uint32_t         >(argv[x++]);
+
+  if (argc != static_cast<int>(2+NB_PARAMS+_nb_execute_loop))
+    usage (argc, argv);
+
+  uint32_t          * _nb_inst_execute          = new uint32_t [_nb_execute_loop];
+  for (uint32_t i=0; i<_nb_execute_loop; i++)
+    _nb_inst_execute [i] = fromString<uint32_t>(argv[x++]);
+
+  uint32_t            _nb_inst_commit           = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _nb_inst_reexecute        = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _nb_execute_loop_select   = fromString<uint32_t         >(argv[x++]);
+  Tpriority_t         _priority                 = fromString<Tpriority_t      >(argv[x++]);
+  Tload_balancing_t   _load_balancing           = fromString<Tload_balancing_t>(argv[x++]);
+  uint32_t            _size_general_register_id = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_special_register_id = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_general_data        = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_special_data        = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_store_queue_ptr     = fromString<uint32_t         >(argv[x++]);
+  uint32_t            _size_load_queue_ptr      = fromString<uint32_t         >(argv[x++]);
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      morpheo::behavioural::core::multi_ooo_engine::ooo_engine::reexecute_unit::Parameters * param = new morpheo::behavioural::core::multi_ooo_engine::ooo_engine::reexecute_unit::Parameters
+	(
+	 _size_context_id         ,
+	 _size_front_end_id       ,
+	 _size_packet_id          ,
+	 _size_queue              ,
+	 _nb_execute_loop         ,
+	 _nb_inst_execute         ,
+	 _nb_inst_commit          ,
+	 _nb_inst_reexecute       ,
+	 _nb_execute_loop_select  ,
+	 _priority                ,
+	 _load_balancing          ,
+	 _size_general_register_id,
+	 _size_special_register_id,
+	 _size_general_data       ,
+	 _size_special_data       ,
+	 _size_store_queue_ptr    ,
+	 _size_load_queue_ptr     ,
+         true //is_toplevel
+        );
+      
+      msg(_("%s"),param->print(0).c_str());
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Reexecute_unit : no error");
+      else
+	TEST_KO("Reexecute_unit : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  delete [] _nb_inst_execute;
+
+  return (_return);
+}
